    MODULE quad_1d_ex02_mod

      ! .. Implicit None Statement ..
      IMPLICIT NONE
      ! .. Default Accessibility ..
      PUBLIC
      ! .. Intrinsic Functions ..
      INTRINSIC KIND
      ! .. Parameters ..
      INTEGER, PARAMETER :: wp = KIND(1.0D0)

    CONTAINS

      FUNCTION g(x)

        ! .. Implicit None Statement ..
        IMPLICIT NONE
        ! .. Intrinsic Functions ..
        INTRINSIC LOG, SIZE
        ! .. Array Arguments ..
        REAL (wp), INTENT (IN) :: x(:)
        ! .. Function Return Value ..
        REAL (wp) :: g(SIZE(x))
        ! .. Executable Statements ..
        WHERE (x>0.0_wp)
          g = LOG(x)
        ELSEWHERE
          g = 0.0_wp
        END WHERE

      END FUNCTION g

    END MODULE quad_1d_ex02_mod

    PROGRAM nag_quad_1d_ex02

      ! Example Program Text for nag_quad_1d
      ! NAG fl90, Release 4. NAG Copyright 2000.

      ! .. Use Statements ..
      USE nag_examples_io, ONLY : nag_std_out
      USE nag_math_constants, ONLY : nag_pi
      USE nag_quad_1d, ONLY : nag_quad_1d_wt_trig
      USE quad_1d_ex02_mod, ONLY : wp, g
      ! .. Implicit None Statement ..
      IMPLICIT NONE
      ! .. Local Scalars ..
      REAL (wp) :: a, b, omega, pi, result
      CHARACTER (1) :: trig_wt
      ! .. Executable Statements ..
      WRITE (nag_std_out,*) 'Example Program Results for nag_quad_1d_ex02'

      pi = nag_pi(0.0_wp)
      a = 0.0_wp
      b = 1.0_wp
      omega = 10.0_wp*pi
      trig_wt = 'sine'

      CALL nag_quad_1d_wt_trig(g,a,b,omega,trig_wt,result)

      WRITE (nag_std_out,'(/,1X,A,F10.4)') &
       'a  - lower limit of integration = ', a
      WRITE (nag_std_out,'(1X,A,F10.4)') 'b  - upper limit of integration = ', b
      WRITE (nag_std_out,'(1X,A,F9.5)') &
       'result - approximation to the integral =', result

    END PROGRAM nag_quad_1d_ex02
